
def cluster_entropy(df):

    #%% import
    from CorpusHomogeneity.text_entropy import corpus_entropy
    import numpy as np

    #%%
    cluster_ids = np.unique(df.cluster)
    ent_mean, ent_std = [None] * len(cluster_ids), [None] * len(cluster_ids)

    for idx, i_cluster in enumerate(cluster_ids):
        if i_cluster == -1: # important to ignore non-clusters texts
            ent_mean[idx] = np.nan
            ent_std[idx] = np.nan
        else:
            t_corpus = df[df['cluster'] == i_cluster]
            t_corpus = t_corpus.text.tolist()
            ent_mean[idx], ent_std[idx] = corpus_entropy(t_corpus)

    #%% output
    ent_mean = np.nanmean(ent_mean)
    ent_std = np.nanstd(ent_mean)

    return ent_mean, ent_std