# -*- coding: iso-8859-1 -*-
import os

##### Script paramseters: Please adapt to own data!!! #####
path_to_reports = '../DataNephroTexts/reports'
author_names = "Name1 Name2 Name3 Name4"   ## names of the pathologists who wrote the reports
splitted_reports_folder_path = '../DataNephroTexts'
path2corpus_bow_preprocessed_diagnosis = 'database/bow_prepro_diag.pkl'
path2corpus_embedding_preprocessed_diagnosis = 'database/embedding_prepro_diag.pkl'
path2corpus_bow_preprocessed_description = 'database/bow_prepro_desc.pkl'
path2corpus_embedding_preprocessed_description = 'database/embedding_prepro_desc.pkl'

# check if we are at correct working directory:
workdir = os.getcwd()
if not workdir[-len('nlp-in-diagnostic-texts-from-nephropathology'):] == 'nlp-in-diagnostic-texts-from-nephropathology':
    print(workdir + " is the wrong working directory.")
    print("please make shure to run this script with working directory '.../path/to/nlp-in-diagnostic-texts-from-nephropathology'.")
    exit(1)

preperateion_queue = [
"python database_preparation/split_reports.py --path_to_reports " + path_to_reports + " --target_folder_path " + splitted_reports_folder_path + " --author_names \"" + author_names + '\"',
f"python database_preparation/preprocess.py --path_to_preprocessing_params {path2corpus_bow_preprocessed_diagnosis.replace('.pkl','_meta.json')} --target_path {path2corpus_bow_preprocessed_diagnosis}",
f"python database_preparation/preprocess.py --path_to_preprocessing_params {path2corpus_embedding_preprocessed_diagnosis.replace('.pkl','_meta.json')} --target_path {path2corpus_embedding_preprocessed_diagnosis}",
f"python database_preparation/preprocess.py --path_to_preprocessing_params {path2corpus_bow_preprocessed_description.replace('.pkl','_meta.json')} --target_path {path2corpus_bow_preprocessed_description}",
f"python database_preparation/preprocess.py --path_to_preprocessing_params {path2corpus_embedding_preprocessed_description.replace('.pkl','_meta.json')} --target_path {path2corpus_embedding_preprocessed_description}",
]

for script in preperateion_queue:
    print("\n########################################### executing ###########################################")
    print(script)
    print("####################################################################################################\n")
    os.system(script)

