import nltk
from database_preparation.utils_wordbase import RegexpReplacer

lst_stopwords_patho = ['Ca.', 'Ca', 'ca.', 'ca' "Circa", "circa"]
#there are a view words in the german nltk.coprus.stopwords-list which we might keep!
lst_stopwords_to_keep = ['keiner', 'keinen', 'keines', 'keinem', 'keine', 'kein']

def filter_stopwords(tokinzed_txt, additional_stop_words = None):
    '''
    - passed text list has to be tokenized!
    '''
    stop_words = nltk.corpus.stopwords.words('german')
    stop_words.extend(lst_stopwords_patho)
    if type(additional_stop_words) == list:
        stop_words.extend(additional_stop_words)
    replacer = RegexpReplacer()
    for word in lst_stopwords_to_keep:
        stop_words.remove(word)
    new_stopwords = []
    for word in stop_words:  # add replaced words to stoplist:
        new_word = replacer.replace(word)
        if word != new_word:
            new_stopwords.append(new_word)
    stop_words.extend(new_stopwords)

    return [w for w in tokinzed_txt if not w.lower() in stop_words]